{$H+}

Unit pmfsettings;

Interface

Uses kol;

//const

{type tpmfsettings =object// class
public}

Var 
  pop3user: string;
  pop3pass: string;
  //[255];
  pop3server: string;
  pop3port: string;
  smtpuser: string;
  smtpusername: string;
  smtppass: string;
  //[255];
  smtpserver: string;
  smtpport: string;
  smtpsendermail: string;
  con_name: string;
  autoconnect: boolean;
  pop3autossl: boolean;
  pop3fullssl: boolean;
  smtpautossl: boolean;
  smtpfullssl: boolean;
  auto_check: boolean;
  check_period: integer;
  autodial: boolean;
Procedure load;
Procedure save;
{private
 procedure ReadWriteIni( Write: Boolean );
 procedure encryptpas;
 procedure descryptpas;
end;
ppmfsettings=^tpmfsettings;
 }
//var pmfs:tpmfsettings;

Implementation

Uses kol_Twofish;

Const key: array[0..7] Of char = 'qm3igmfk';


Procedure {tpmfsettings.}ReadWriteIni( Write: Boolean );

Var Ini: PIniFile;
  // cfg: TXMLConfig;
Begin
  Ini := OpenIniFile( getstartdir+'pmf_settings.ini' );
  Ini.Section := 'Main';
  If Write Then            // if Write, the same operators will save
    Ini.Mode := ifmWrite;
  // data rather then load.
  pop3user := ini.valuestring('pop3user',pop3user);
  pop3pass := ini.valuestring('pop3pass',pop3pass);
  pop3server := ini.valuestring('pop3server',pop3server);
  pop3port := ini.valuestring('pop3port',pop3port);
  smtpuser := ini.valuestring('smtpuser',smtpuser);
  smtpusername := ini.valuestring('smtpusername',smtpusername);
  smtppass := ini.valuestring('smtppass',smtppass);
  smtpserver := ini.valuestring('smtpserver',smtpserver);
  smtpport := ini.valuestring('smtpport',smtpport);
  smtpsendermail := ini.valuestring('smtpsendermail',smtpsendermail);
  pop3autossl := ini.valueboolean('pop3autossl',pop3autossl);
  con_name := ini.valuestring('con_name',con_name);
  pop3fullssl := ini.valueboolean('pop3fullssl',pop3fullssl);
  smtpautossl := ini.valueboolean('smtsfullssl',smtpautossl);
  smtpfullssl := ini.valueboolean('smtpfullssl',smtpfullssl);
  auto_check := ini.valueboolean('auto_check',auto_check);
  check_period := ini.valueinteger('check_period',check_period);
  autoconnect := ini.valueboolean('autoconnect',autoconnect);
  autodial := ini.valueboolean('autodial',autodial);

  Ini.Free;
End;


Function s2hex(s:String): string;

Var 
  i: integer;
Begin
  For i:=1 To strlen(pchar(s)) Do
    Begin
      Result := Result+Int2Hex(ord(s[i]),2);
    End;
End;

Function hex2s(s:String): string;

Var 
  i,l,n: integer;
  b: string;
Begin
  l := strlen(pchar(s));
  i := 1;
  While {not}(i<l) Do
    Begin
      b := s[i]+s[i+1];
      n := hex2int(b);
      Result := Result+chr(n);
      inc(i);
      inc(i);
    End;

End;


Procedure {tpmfsettings.}encryptpas;

Var 
{inbuf,}outbuf: string;
  buf: string;
  tfdata: ttwofishdata;
Begin
  buf := pop3pass;
  If Not (buf='') Then
    Begin
      TwofishInit(tfdata,key,8,Nil);
      setlength(outbuf,length(buf));
      twofishencryptcbc(tfdata,buf[1],outbuf[1],length(buf));
      pop3pass := s2hex(outbuf);
      TwofishReset(tfdata);
      TwoFishBurn(tfdata);
    End;

  buf := smtppass;
  If Not (buf='') Then
    Begin
      TwofishInit(tfdata,key,8,Nil);
      //outbuf:='';
      setlength(outbuf,length(buf));
      twofishencryptcbc(tfdata,buf[1],outbuf[1],length(buf));
      TwofishReset(tfdata);
      TwoFishBurn(tfdata);

      smtppass := s2hex(outbuf);
    End;
End;

Procedure {tpmfsettings.}descryptpas;

Var 
  inbuf,outbuf: string;
  tfdata: ttwofishdata;
Begin
  If Not (pop3pass='') Then
    Begin
      inbuf := hex2s(pop3pass);
      TwofishInit(tfdata,key,8,Nil);
      setlength(outbuf,length(inbuf));
      twofishdecryptcbc(tfdata,inbuf[1],outbuf[1],length(inbuf));
      TwofishReset(tfdata);
      TwoFishBurn(tfdata);
      pop3pass := outbuf;
      inbuf := '';
      outbuf := '';
    End;

  If Not (smtppass='') Then
    Begin
      inbuf := hex2s(smtppass);
      TwofishInit(tfdata,key,8,Nil);
      setlength(outbuf,length(inbuf));
      twofishdecryptcbc(tfdata,inbuf[1],outbuf[1],length(inbuf));
      smtppass := outbuf;
      TwofishReset(tfdata);
      TwoFishBurn(tfdata);
    End;
End;

Procedure {tpmfsettings.}load;
Begin
  ReadWriteIni( false );
  descryptpas;
End;

Procedure {tpmfsettings.}save;
Begin
  encryptpas;
  ReadWriteIni( true );
End;

End.
